<template>
  <div class="slides-section">
    <div class="slider-desktop">
      <client-only>
        <slick-slide
          ref="slick"
          :options="slickOptionsDesktop"
          class="slides-slick custom-slick"
        >
          <SlidesSectionItem
            v-for="(item, index) of data.items"
            :key="`slide-${index}`"
            :item="item"
            @click-slide="clickSlide"
          />
        </slick-slide>
      </client-only>
    </div>

    <div class="slider-mobile">
      <client-only>
        <slick-slide
          ref="slick"
          :options="slickOptionsMobile"
          class="slides-slick custom-slick"
        >
          <SlidesSectionItemMobile
            v-for="(item, index) of data.items"
            :key="`slide-${index}`"
            :item="item"
            @click-slide="clickSlide"
          />
        </slick-slide>
      </client-only>
    </div>
  </div>
</template>

<script>
import SlidesSectionItem from '~/components/sections/SlidesSectionItem'
import SlidesSectionItemMobile from '~/components/sections/SlidesSectionItemMobile'

const slickOptions = {
  dots: true,
  infinite: true,
  prevArrow: '<button type="button" class="slick-prev"></button>',
  nextArrow: '<button type="button" class="slick-next"></button>',
  lazyLoad: 'ondemand',
  adaptiveHeight: true,
  autoplay: true,
  autoplaySpeed: 5000
}

export default {
  components: {
    SlidesSectionItem,
    SlidesSectionItemMobile
  },
  props: {
    data: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      slickOptionsDesktop: slickOptions,
      slickOptionsMobile: {
        ...slickOptions,
        prevArrow: false,
        nextArrow: false
      },
      gtmPushedPromos: []
    }
  },

  mounted() {
    // push first promo slide to dataLayer
    if (this.data.items) {
      this.gtmPushPromoSlideByNumber(0)
    }

    this.$nextTick(() => {
      this.nextTickInit()
    })
  },

  methods: {
    nextTickInit() {
      if (this.$refs && this.$refs.slick) {
        $(this.$refs.slick.$el).on(
          'afterChange',
          (event, slick, currentSlide) => {
            this.gtmPushPromoSlideByNumber(currentSlide)
          }
        )
      }
    },

    clickSlide(params) {
      const { id, title } = params.item
      const promoObj = this.$utils.gtmAdvEcommerceCreatePromoObj(
        id,
        title,
        'slides',
        this.gtmPushedPromos.indexOf(id) + 1
      )
      const evt = this.$utils.gtmAdvEcommerceCreatePromoClickEvent(promoObj)
      this.$utils.gtmEvent(evt)

      this.$utils.gtmEvent(
        {
          event: 'gtm.event',
          EventCategory: 'Slider',
          EventAction: 'Clic',
          EventLabel: params.label
        },
        params.url
      )
    },

    gtmPushPromoSlideByNumber(slideNo) {
      if (this.data.items) {
        const { id, title } = this.data.items[slideNo]
        if (this.gtmPushedPromos.indexOf(id) < 0) {
          const promoObj = this.$utils.gtmAdvEcommerceCreatePromoObj(
            id,
            title,
            'slides',
            slideNo + 1
          )
          const evt = this.$utils.gtmAdvEcommerceCreatePromoImpressionEvent([
            promoObj
          ])
          this.$utils.gtmEvent(evt)
          this.gtmPushedPromos.push(id)
        }
      }
    }
  }
}
</script>

<style lang="scss">
.slides-section {
  height: 600px;
  width: 100%;
  max-width: 1360px;
  margin: 0 auto 36px;
  position: relative;

  .slider-mobile {
    display: none;

    .slick-arrow {
      display: none;
    }
  }

  .slider-desktop {
    margin-top: 2rem;
    display: block;

    .slides-slick {
      padding: 0 1.5rem;
    }
  }

  @media (min-width: 1440px) {
    .slider-desktop {
      .slides-slick {
        padding: 0;
      }
      .custom-slick {
        .slick-prev {
          left: -7px;
        }
        .slick-next {
          right: -7px;
        }
      }
    }
  }

  @media (max-width: 768px) {
    .slider-mobile {
      display: block;
    }

    .slider-desktop {
      display: none;
    }
  }

  .slides-slick {
    margin-bottom: 36px;

    .slick-track {
      width: 100vh;
      display: flex;
      align-items: flex-start;
      justify-content: space-between;
    }

    .slick-dots {
      position: absolute;
      height: 10px;
      bottom: 1rem;
      right: calc(60% - 25px);

      @media (max-width: 768px) {
        top: 1rem;
        right: 0.25rem;
      }

      li {
        display: inline-block;
        padding: 0 3px;

        button {
          cursor: pointer;
          width: 8px;
          height: 8px;
          background-color: #808080;

          @media (max-width: 768px) {
            background-color: #d3d3d3;
          }

          border-radius: 99999px;
          text-indent: -9999px;
        }
        &.slick-active {
          button {
            background-color: #ff641e;
          }
        }
      }
    }
  }
}
</style>
